import 'package:flutter/material.dart';
import 'package:nb_utils/nb_utils.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  void initState() {
    super.initState();

    // Subscribe to a channel
    LiveStream liveStream = LiveStream();
    liveStream.on('test_stream', (value) {
      // Do something with received value
    });
  }

  @override
  Widget build(BuildContext context) {
    //
    launchNewScreen(context, 'tag');
    launchNewScreenWithNewTask(context, 'tag');
    finish(context);
    Color color = getColorFromHex('#FFFFF');

    return MaterialApp(
      title: 'Flutter Utils Example',
      theme: ThemeData(
        primarySwatch: whiteColor,
      ),
      home: HomePage(),
    );
  }
}

class HomePage extends StatefulWidget {
  @override
  _HomePageState createState() => _HomePageState();
}

class _HomePageState extends State<HomePage> {
  @override
  void initState() {
    super.initState();

    // Send anything to a channel
    LiveStream liveStream = LiveStream();
    liveStream.emit('test_stream', 'Second Page');
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        HomePage().launch(context);
      },
      child: Container(
        child: Text('Simple Text').withStyle(),
      ),
    );
  }
}
